package net.t2code.automatedMessages.config;

import org.bukkit.Sound;

public enum Config {

    updateCheckOnJoin("plugin.updateCheck.onJoin", true, ConfigParam.BOOLEAN),
    updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, ConfigParam.BOOLEAN),
    updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, ConfigParam.INTEGER),

    prefix("plugin.prefix", "<dark_gray>[<dark_red>T2C</dark_red>-<color:#5cff5c>Automated</color><color:#69d2ff>Messages</color>]</dark_gray>", ConfigParam.STRING),
    sendConsole("plugin.broadcastInConsole", true, ConfigParam.BOOLEAN),

    timeFormat("plugin.timeFormat", "HH:mm:ss yyyy/MM/dd", ConfigParam.STRING),

    msgReloadStart("plugin.messages.reloadStart", "Reload start", ConfigParam.STRING),
    msgReloadEnd("plugin.messages.reloadEnd", "Reload end", ConfigParam.STRING),

    message("messages",
            "messages.KEY.enable", false,
            "messages.KEY.message", "",
            "messages.KEY.sound.enable", true,
            "messages.KEY.sound.sound", FileBuild.sound(),
            "messages.KEY.permissionNeededToSeeMessage.enable", false,
            "messages.KEY.permissionNeededToSeeMessage.permission", "",
            "messages.KEY.intervalInMin", 0,
            "messages.KEY.exactTime.enable", false,
            "messages.KEY.exactTime.timeMinute", "*/5",
            "messages.KEY.exactTime.timeHour", "*",
            "messages.KEY.exactTime.timeDayOfMonth", "*",
            "messages.KEY.exactTime.timeMonth", "*",
            "messages.KEY.exactTime.timeDayOfWeek", "*",
            ConfigParam.MESSAGE
    );


    public String path;
    public String valueString;
    public Boolean valueBoolean;
    public Integer valueInteger;

    public String msgPath;
    public String msgEnablePath;
    public Boolean msgEnable;

    public String msgMsgPath;
    public String msgMsg;

    public String soundEnablePath;
    public Boolean soundEnable;

    public String soundPath;
    public Sound sound;

    public String permissionNeededToSeeMessagePath;
    public Boolean permissionNeededToSeeMessage;

    public String permissionPath;
    public String permission;

    public String msgIntervalPath;
    public Integer msgInterval;

    public String exactTimePath;
    public Boolean exactTime;

    public String timeMinutePath;
    public String timeMinute;

    public String timeHourPath;
    public String timeHour;

    public String timeDayOfMonthPath;
    public String timeDayOfMonth;

    public String timeMonthPath;
    public String timeMonth;

    public String timeDayOfWeekPath;
    public String timeDayOfWeek;

    public ConfigParam configParam;

    Config(String path, String value, ConfigParam cEnum) {
        this.path = path;
        this.valueString = value;
        this.configParam = cEnum;
    }

    Config(String path, Integer value, ConfigParam cEnum) {
        this.path = path;
        this.valueInteger = value;
        this.configParam = cEnum;
    }

    Config(String path, Boolean value, ConfigParam cEnum) {
        this.path = path;
        this.valueBoolean = value;
        this.configParam = cEnum;
    }

    Config(String msgPath,
           String msgEnablePath, Boolean msgEnable,
           String msgMsgPath, String msgMsg,
           String soundEnablePath, Boolean soundEnable,
           String soundPath, Sound sound,
           String permissionNeededToSeeMessagePath, Boolean permissionNeededToSeeMessage,
           String permissionPath, String permission,
           String msgIntervalPath, Integer msgInterval,
           String exactTimePath, Boolean exactTime, String timeMinutePath, String timeMinute,
           String timeHourPath, String timeHour,
           String timeDayOfMonthPath, String timeDayOfMonth,
           String timeMonthPath, String timeMonth,
           String timeDayOfWeekPath, String timeDayOfWeek,
           ConfigParam configParam) {
        this.msgPath = msgPath;
        this.msgEnablePath = msgEnablePath;
        this.msgEnable = msgEnable;
        this.msgMsgPath = msgMsgPath;
        this.msgMsg = msgMsg;

        this.soundEnablePath = soundEnablePath;
        this.soundEnable = soundEnable;
        this.soundPath = soundPath;
        this.sound = sound;

        this.permissionNeededToSeeMessagePath = permissionNeededToSeeMessagePath;
        this.permissionNeededToSeeMessage = permissionNeededToSeeMessage;
        this.permissionPath = permissionPath;
        this.permission = permission;

        this.msgIntervalPath = msgIntervalPath;
        this.msgInterval = msgInterval;
        this.exactTimePath = exactTimePath;
        this.exactTime = exactTime;
        this.timeMinutePath = timeMinutePath;
        this.timeMinute = timeMinute;
        this.timeHourPath = timeHourPath;
        this.timeHour = timeHour;

        this.timeDayOfMonthPath = timeDayOfMonthPath;
        this.timeDayOfMonth = timeDayOfMonth;
        this.timeMonthPath = timeMonthPath;
        this.timeMonth = timeMonth;
        this.timeDayOfWeekPath = timeDayOfWeekPath;
        this.timeDayOfWeek = timeDayOfWeek;
        this.configParam = configParam;
    }
}
